#!/usr/bin/env python3
n, s = map(int, input().split())
kingdoms = [0, *((a, b + s) for a, b in (map(int, input().split()) for _ in range(n)))]

dist = [[3 * s] * (2 * s + 1) for _ in range(2 * s + 1)]
for a, b in kingdoms[1:]:
    dist[a][b] = dist[b][a] = 1
for i in range(2 * s + 1):
    dist[i][i] = 0

for k in range(1, 2 * s + 1):
    for i in range(1, 2 * s + 1):
        for j in range(1, 2 * s + 1):
            dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j])

for _ in range(int(input())):
    (a, b), (c, d) = (kingdoms[int(i)] for i in input().split())
    ans = min(dist[a][c], dist[a][d], dist[b][c], dist[b][d])
    print(-1 if ans == 3 * s else ans + 1)
