#!/usr/bin/env python3
n, s = map(int, input().split())

dist = [[1e9] * (2 * s) for _ in range(2 * s)]
l = [0] * n
r = [0] * n

for i in range(n):
    l[i], r[i] = map(int, input().split())
    l[i] -= 1
    r[i] -= 1
    r[i] += s

    dist[l[i]][r[i]] = 1
    dist[r[i]][l[i]] = 1

for i in range(2 * s):
    dist[i][i] = 0

for k in range(2 * s):
    for i in range(2 * s):
        for j in range(2 * s):
            dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j])

for _ in range(int(input())):
    i, j = map(int, input().split())
    i -= 1
    j -= 1
    ans = min(dist[l[i]][l[j]], dist[l[i]][r[j]], dist[r[i]][l[j]], dist[r[i]][r[j]])
    print(-1 if ans == 1e9 else ans + 1)
