#include <iostream>
#include <vector>
using namespace std;

#define rep(i,n) for (int i = 0; i < (n); i++)

int main() {
	int n, s;
	cin >> n >> s;

	vector<pair<int,int>> coa(n);
	for (auto &[a,b]: coa) {
		cin >> a >> b;
		a -= 1, b += s-1;
	}

	vector<vector<int>> dist(2*s, vector<int>(2*s, 1e9));
	for (auto [a,b]: coa) {
		dist[a][b] = dist[b][a] = 1;
	}
	rep(a,2*s) dist[a][a] = 0;

	rep(b,2*s) rep(a,2*s) rep(c,2*s) {
		dist[a][c] = min(dist[a][c], dist[a][b]+dist[b][c]);
	}
	
	int q; cin >> q;
	while  (q--) {
		int i, j;
		cin >> i >> j;
		auto [a,b] = coa[i-1];
		auto [c,d] = coa[j-1];
		int res = min(min(dist[a][c], dist[a][d]), min(dist[b][c], dist[b][d]));
		cout << (res >= 1e9 ? -1 : res + 1) << '\n';
	}
}
