import java.util.*;
public class InteractivePK{

   final static String OVERFLOW = "ArrayIndexOutOfBoundsException";
   public static void main (String [] args){
      InteractivePK problem = new InteractivePK(new Extern());
      problem.run();
   }
////////////////////////////////////////
   Interaction ch;
   int champ;

   InteractivePK(Interaction chIn){
      ch = chIn;
   }

   void run(){
      int champ = 0;
      int row;
      int bound = 2000;
      for (row = 1; row <= bound; row++)
         for(int col = 1; col <= bound; col++){
            ch.send("? " + row + " " + col);
            String line = ch.read();
            if (line.equals(OVERFLOW)){
               bound = col - 1;
               break;
            }
            else{
               int num = Integer.parseInt(line);
               if (num > champ)
                  champ = num;
            }
         }
      ch.send("! " + champ);
   }

}

interface Interaction{
   void send(String comm);
   String read();
}

class Extern implements Interaction{

   static Scanner sc = new Scanner(System.in);

   public void send(String comm){
      System.out.println(comm);
      System.out.flush();
   }
  
   public String read(){
      String line = sc.nextLine();
      return line;
   }
}