#include <iostream>
#include <set>
using namespace std;

int main() {
	srand(987);
	int n = 123, res = 0;
	set<pair<int,int>> visited;
	while (size(visited) < n*n) {
		int i = 1 + rand() % n;
		int j = 1 + rand() % n;
		if (visited.count({i,j})) continue;
		printf("? %d %d\n", i, j);
		fflush(stdout);
		string ans; cin >> ans;
		if (ans == "ArrayIndexOutOfBoundsException") {
			n = min(n, min(i,j));
		} else {
			visited.insert({i,j});
			res = max(res, stoi(ans));
		}
	}
	printf("! %d\n", res);
}
