#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define mp make_pair
#define eb emplace_back
#define all(a) begin(a), end(a)
#define has(a, b) (a.find(b) != a.end())
#define fora(i, n) for(int i = 0; i < n; i++)
#define forb(i, n) for(int i = 1; i <= n; i++)
#define forc(a, b) for(const auto &a : b)
#define ford(i, n) for(int i = n; i >= 0; i--)
#define maxval(t) numeric_limits<t>::max()
#define minval(t) numeric_limits<t>::min()
#define imin(a, b) a = min(a, b)
#define imax(a, b) a = max(a, b)
#define sz(x) (int)(x).size()
#define pvec(v) copy(all(v), ostream_iterator<decltype(v)::value_type>(cout, " "))

#define dbgs(x) #x << " = " << x
#define dbgs2(x, y) dbgs(x) << ", " << dbgs(y)
#define dbgs3(x, y, z) dbgs2(x, y) << ", " << dbgs(z)
#define dbgs4(w, x, y, z) dbgs3(w, x, y) << ", " << dbgs(z)

using ll = long long;
using ld = long double;

constexpr ll inf = 1000000000;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, s;
	cin >> n >> s;

	vector<vector<ll>> g(2 * s);

	vector<ll> l(n), r(n);

	fora(i, n) {
		cin >> l[i] >> r[i];
		--l[i]; --r[i];
		r[i] += s;
	}

	fora(i, n) {
        g[l[i]].pb(r[i]);
        g[r[i]].pb(l[i]);
	}

	vector<vector<ll>> dist(2 * s, vector<ll>(2 * s, inf));
	fora(a, 2 * s) {
        dist[a][a] = 0;
		ll d = 0;
		vector<bool> seen(2 * s, false);
		deque<ll> *queue = new deque<ll>(), *old_queue;
		queue->pb(a);

		while (!queue->empty()) {
		    d++;
		    old_queue = queue;
		    queue = new deque<ll>();
		    for (ll curr : *old_queue) {
                seen[curr] = true;
                for (ll neigh : g[curr]) {
                    if (!seen[neigh]) {
                        queue->pb(neigh);
                        dist[a][neigh] = d;
                    }
                }
		    }
		}
	}

	int q;
	cin >> q;

	fora(_, q) {
		int i, j;
		cin >> i >> j;
		--i; --j;
		ll ans = min({dist[l[i]][l[j]], dist[l[i]][r[j]],
				dist[r[i]][l[j]], dist[r[i]][r[j]]});
		cout << (ans == inf ? -1 : ans + 1) << '\n';
	}
}
