#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define mp make_pair
#define eb emplace_back
#define all(a) begin(a), end(a)
#define has(a, b) (a.find(b) != a.end())
#define fora(i, n) for(int i = 0; i < n; i++)
#define forb(i, n) for(int i = 1; i <= n; i++)
#define forc(a, b) for(const auto &a : b)
#define ford(i, n) for(int i = n; i >= 0; i--)
#define maxval(t) numeric_limits<t>::max()
#define minval(t) numeric_limits<t>::min()
#define imin(a, b) a = min(a, b)
#define imax(a, b) a = max(a, b)
#define sz(x) (int)(x).size()
#define pvec(v) copy(all(v), ostream_iterator<decltype(v)::value_type>(cout, " "))

#define dbgs(x) #x << " = " << x
#define dbgs2(x, y) dbgs(x) << ", " << dbgs(y)
#define dbgs3(x, y, z) dbgs2(x, y) << ", " << dbgs(z)
#define dbgs4(w, x, y, z) dbgs3(w, x, y) << ", " << dbgs(z)

using ll = long long;
using ld = long double;

constexpr ll inf = 1000000000;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, s;
	cin >> n >> s;

	vector<vector<ll>> g(n);

	vector<vector<ll>> wl(s), wr(s);

	fora(i, n) {
		int l, r;
		cin >> l >> r;
		--l; --r;

		wl[l].pb(i);
		wr[r].pb(i);
	}

	fora(i, s) {
		forc(u, wl[i]) forc(v, wl[i]) {
			if (u == v) continue;
			g[u].pb(v);
			g[v].pb(u);
		}
		forc(u, wr[i]) forc(v, wr[i]) {
			if (u == v) continue;
			g[u].pb(v);
			g[v].pb(u);
		}
	}

	int q;
	cin >> q;

	fora(_, q) {
		int u, v;
		cin >> u >> v;
		--u; --v;

		vector<ll> dist(n, inf);
		dist[u] = 0;
		deque<ll> todo;
		todo.pb(u);

		while (!todo.empty()) {
			ll cur = todo.front();
			todo.pop_front();
			forc(ne, g[cur]) {
				if (dist[ne] != inf) continue;
				dist[ne] = dist[cur] + 1;
				todo.pb(ne);
			}
			if (dist[v] != inf) break;
		}

		cout << (dist[v] == inf ? -1 : dist[v]) << '\n';
	}
}
