import java.io.*;
import java.util.*;

public class MaartenJava17 {
    public static void main(String[] args) throws IOException {
        try (BufferedReader reader = new BufferedReader(new InputStreamReader(System.in))) {
            new MaartenJava17().run(new Scanner(reader));
        }
    }

    public void run(Scanner sc) throws IOException {
        // Java 14: Switch Expression
        System.out.println(switch (42) {
            default -> 2 * Math.sqrt(sc.nextDouble() / Math.PI);
        });
    }

    // Java 17: Sealed Classes
    sealed abstract static class A {
    }

    static final class B extends A {
    }
}
